<?php
namespace App\ApiResource;

use ApiPlatform\Metadata\ApiResource;

#[ApiResource]
class Dojo extends Thing
{

    public string $name;

    /**
     * The unique identifier of the owner of this Dojo
     *
     * @ApiPlatform\ApiProperty(writable=false, description="owner of the dojo (player)")
     * @ApiPlatform\ApiSubresource(maxDepth=1)
     */
    public Player $owner;

    /**
     *
     * @ApiPlatform\ApiSubresource(maxDepth=1)
     * @var Character[]
     */
    public iterable $members;

    /**
     *
     * @ApiPlatform\ApiProperty
     */
    public Village $village;

    /**
     * Helper method that reads the timestamp section from the ulid
     */
    public function getCreatedAt(): \DateTimeImmutable
    {
        return $this->id->getDateTime();
    }
}

